;*********************************************************************************
infile = 'XSM_NE_R00300_00.DAT'
;*********************************************************************************

data = mrdfits(infile, 1, header, /silent)

spectra = data.spectrum
spectra[0, *] = 0
spectra[511, *] = 0

FOR I=0, 4 DO BEGIN
SPECTRA(*,I)=0.
ENDFOR

indices = where(data.flag eq 1)
n_calibration = (size(indices, /dimensions))[0]
C = (data.spectrum)[*, indices]

NT=N_ELEMENTS(DATA)

ML=24
TL=10

C(0,*)=0.
C(511,*)=0.

N_B=N_ELEMENTS(indices)

C_TOT=DBLARR(512)

FOR W=0, 511 DO BEGIN
C_TOT(W)=TOTAL(C(W,*))
ENDFOR

TABT=DBLARR(6)

Mn_CHBT=WHERE(C_TOT EQ MAX(C_TOT))
Mn_CHBT0=Mn_CHBT(0)
MnBT1=Mn_CHBT0-ML
MnBT2=Mn_CHBT0+ML

XBT=FINDGEN(512)
XBT1=XBT(MnBT1:MnBT2)
YBT1=C_TOT[MnBT1:MnBT2]
YBTF1=GAUSSFIT(XBT1, YBT1, ABT)

Mn_CENTBT=ABT(1)
Mn_SIGMABT=ABT(2)
TABT(1)=Mn_CENTBT

DABT=DBLARR(512)
DABT=C_TOT
DABT(Mn_CHBT0-22:*)=0
Ti_MAXBT=MAX(DABT)

Ti_CHBT=WHERE(DABT EQ MAX(DABT))
Ti_CHBT0=Ti_CHBT(0)
TiBT1=Ti_CHBT0-TL
TiBT2=Ti_CHBT0+TL

XBT=FINDGEN(512)
XBT2=XBT(TiBT1:TiBT2)
YBT2=DABT[TiBT1:TiBT2]
YBTF2 = GAUSSFIT(XBT2, YBT2, BBT)

Ti_CENTBT=BBT(1)
Ti_SIGMABT=BBT(2) 
TABT(0)=Ti_CENTBT
KBT1=Ti_CENTBT
KBT2=Mn_CENTBT
E1=4.5088
E2=5.8951

!X.TITLE=1
!Y.TITLE=1

PLOT, C_TOT, XTITLE='CHANNEL #', YTITLE='TOTAL COUNTS', TITLE='SUM OF APPLIED CALIBRATION SPECTRA', CHARSIZE=1.5, CHARTHICK=2, XR=[0,512],YR=[0,MAX(C_TOT)+10], THICK=2

WAIT, 1

GAIN_ABT=(E2-E1)/(KBT2-KBT1)
TABT(4)=GAIN_ABT
OFFSET_ABT=E2-(E2-E1)*KBT2/(KBT2-KBT1)
TABT(5)=OFFSET_ABT
E_RES_MnBT=2.35*Mn_SIGMABT*GAIN_ABT
TABT(3)=E_RES_MnBT
E_RES_TiBT=2.35*Ti_SIGMABT*GAIN_ABT
IF E_RES_TiBT GE E_RES_MnBT THEN E_RES_TiBT=E_RES_MnBT*SQRT(E1/E2)
TABT(2)=E_RES_TiBT

PRINT,'Ti 4.5 keV Mn 5.9 keV, ENERGY=GAIN*CHANNEL#+OFFSET'
PRINT, '       Ti Centroid    ', ' Mn Centroid    ', 'Ti Res      ', '    Mn Res      ', '   Gain      ', '       Offset'
PRINT, TABT(*)
PRINT,''

TiC=KBT1
MnC=KBT2
TiR=E_RES_TiBT
MnR=E_RES_MnBT
GAIN=GAIN_ABT
OFFSET=OFFSET_ABT

PRINT,'*****ADOPTED VALUES FOR RMF*****'
PRINT,'Ti-reso (eV):'
PRINT,TiR
PRINT,'Mn-reso (eV):' 
PRINT,MnR
PRINT,'GAIN (eV/ch):'
PRINT,GAIN
PRINT,'OFFSET (eV):'
PRINT,OFFSET
PRINT,''
EMIN=FLTARR(512)
EMAX=FLTARR(512)
EL=FLTARR(512)
EH=FLTARR(512)

RN=INFILE
STRPUT, RN, '.RMF', 16
          
FOR I1=1, 511 DO BEGIN
EMIN(I1)=GAIN*(I1-1)+OFFSET
EMAX(I1)=GAIN*I1+OFFSET
ENDFOR
                                                                                                        
BAD_CH=WHERE(EMIN LT 0. OR EMAX GT 20.)
PRINT,'IGNORE CHANNELS BELOW'
PRINT, BAD_CH
                                                                                                        
FOR M=0, 511 DO BEGIN
IF EMIN(M) GE 20. THEN EL(M)=20
IF EMAX(M) GE 20. THEN EH(M)=20.
IF (EMIN(M) GE 0. AND EMIN(M) LE 20.) THEN EL(M)=EMIN(M)
IF (EMAX(M) GE 0. AND EMAX(M) LE 20.) THEN EH(M)=EMAX(M)
IF EMIN(M) LT 0. THEN EL(M)=0.
IF EMAX(M) LT 0. THEN EH(M)=0.
ENDFOR

X3=[0.0, 4.5088, 5.8951]
Y3=[0.100^2, (TiR)^2, (MnR)^2]
RESULT=LINFIT(X3, Y3, MEASURE_ERRORS=measure_errors)
F=DBLARR(2)
F=RESULT
V2=F(0)  ;RESO OFFSET
V1=F(1)  ;RESO GAIN 

E_MIN=EL
E_MAX=EH
E_LOW=FINDGEN(512)*39.0625/1000.
E_HIGH=FINDGEN(512)*39.0625/1000.+39.0625/1000.

A=0.5*(E_LOW+E_MAX)

LWC=50.
LWE=A(LWC)
ENL=MAX(WHERE(E_HIGH LE LWE))-1.

FWHM=SQRT(V1*A+V2)
PLOT, A, XR=[0,MAX(E_MAX)], YR=[0,0.5], FWHM, YTITLE='FWHM, eV', XTITLE='PHOTON ENERGY / keV', TITLE='XSM ENERGY RESOLUTION', THICK=2, CHARSIZE=1.5, CHARTHICK=2
WAIT, 1
MU_SI=READFITS('MU_SI.FITS')
F=FLTARR(512)
GM=FLTARR(512)
GP=FLTARR(512)

EB=FINDGEN(512)/511.*20.103
EE=FINDGEN(512)/511.*20.0
MU=INTERPOL(MU_SI, EB, EE)

V_2=V2*0.18033688
V_1=V1*0.18033688

HYP=FLTARR(512,512)

FOR I2=0, 511 DO BEGIN
E=MAX(A)*I2/511
S=SQRT(V_1*E+V_2)
F=MU(I2)
GM=1.0*EXP(-(A-E)^2/(2.*S*S))
GM=GM>0.000000000001
IF E LT 1.747 THEN K=0
IF E GT 1.747 THEN K=0.023*(1-(851./F)*ALOG(1.+(F/851.)))*TOTAL(GM)
GP=K*EXP(-(A-E+1.747)^2/(2.*S*S))
GP=GP>0.000000000001
D_TOT=FLTARR(512)
D_TOT=(GM+GP)/(TOTAL(GM)+TOTAL(GP))
HYP(*,I2)=D_TOT
ENDFOR

H=DBLARR(512,512)
FOR J2=0, 511 DO BEGIN
H(*, J2)=HYP(0:511, J2)
ENDFOR

!X.STYLE=1
!Y.STYLE=1

PLOT, H(*,20), XR=[0,512], YR=[0,0.35], THICK=2, TITLE='XSM REDISTRIBUTION CURVES AS A FUNCTION OF PHOTON ENERGY', XTITLE='MULTIPLE PLOT OF  RMF ROWS', YTITLE='PROPABILITY', CHARSIZE=1.5, CHARTHICK=2

FOR N1=15, 511, 20 DO BEGIN
OPLOT, H(*,N1), THICK=2
WAIT, 0.1
ENDFOR

HYPERMET=H

N_GRP=INDGEN(512)
N_GRP(*)=1
F_CHAN=INDGEN(512)
F_CHAN(*)=1
N_CHAN=INDGEN(512)
N_CHAN(*)=512

PDR_0=STRARR(5)
PDR_0(0)='SIMPLE  =                       T / file does conform to FITS standard'
PDR_0(1)='BITPIX  =                       8 / number of bits per data pixel'
PDR_0(2)='NAXIS   =                       0 / number of data axes'
PDR_0(3)='EXTEND  =                       T / FITS dataset may contain extensions'
;PDR_0(4)='END'

PDR_1=STRARR(35)
PDR_1(0)='XTENSION= ''BINTABLE''            / binary table extension'
PDR_1(1)='BITPIX  =                       8 / 8-bit bytes'
PDR_1(2)='NAXIS   =                       2 / 2-dimensional binary table'
PDR_1(3)='NAXIS1  =                    2062 / width of table in bytes'
PDR_1(4)='NAXIS2  =                     512 / number of rows in table'
PDR_1(5)='PCOUNT  =                       0 / size of special data area'
PDR_1(6)='GCOUNT  =                       1 / one data group (required keyword)'
PDR_1(7)='TFIELDS =                       6 / number of fields in each row'
PDR_1(8)='TTYPE1  = ''ENERG_LO''            / label for field'
PDR_1(9)='TFORM1  = ''1E      ''            / format of field: 4 b'
PDR_1(10)='TUNIT1  = ''keV    ''            / unit of field'
PDR_1(11)='TTYPE2  = ''ENERG_HI''           / label for field'
PDR_1(12)='TFORM2  = ''1E     ''            / format of field: 4 b'
PDR_1(13)='TUNIT2  = ''keV    ''            / unit of field'
PDR_1(14)='TTYPE3  = ''N_GRP  ''            / label for field'
PDR_1(15)='TFORM3  = ''1I     ''            / format of field: 2 b'
PDR_1(16)='TTYPE4  = ''F_CHAN ''            / label for field'
PDR_1(17)='TFORM4  = ''1I     ''            / format of field: 2 b'
PDR_1(18)='TTYPE5  = ''N_CHAN ''            / label for field'
PDR_1(19)='TFORM5  = ''1I     ''            / format of field: 2 b'
PDR_1(20)='TTYPE6  = ''MATRIX ''            / label for field'
PDR_1(21)='TFORM6  = ''512E   ''            / format of field: 2048 b'
PDR_1(22)='EXTNAME = ''MATRIX ''            / Extension name'
PDR_1(23)='INSTRUME= ''XSM    ''            / instrumennt name
PDR_1(24)='HDUCLASS= ''OGIP   ''            / format conforms to OGIP/GSFC conventions'
PDR_1(25)='HDUCLAS1= ''RESPONSE''           / Dataset contains a response mateix'
PDR_1(26)='HDUCLAS2= ''RSP_MATRIX''         / Extension contains response matrix'
PDR_1(27)='HDUVERS = ''1.3.0  ''            / version number of the format'
PDR_1(28)='CHANTYPE= ''PHA    ''            / Type of detector channels'
PDR_1(29)='DETCHANS=                    512 / Total number of PI channels in the full matrix'
PDR_1(30)='TLMIN   =                      1 / Channel number of first channel'
PDR_1(31)='LO_THRES=                      0./ Lowest value in MATRIX
PDR_1(32)='TELESCOP= ''CHAND-1''      / telescope (mission) name'
PDR_1(33)='FILTER  = ''none   ''            / filter not specified'

PDR_2=STRARR(30)
PDR_2(0)='XTENSION= ''BINTABLE''            / binary table extension'
PDR_2(1)='BITPIX  =                       8 / 8-bit bytes'
PDR_2(2)='NAXIS   =                       2 / 2-dimensional binary table'
PDR_2(3)='NAXIS1  =                      10 / width of table in bytes'
PDR_2(4)='NAXIS2  =                     512 / number of rows in table'
PDR_2(5)='PCOUNT  =                       0 / size of special data area'
PDR_2(6)='GCOUNT  =                       1 / one data group (required keywor'
PDR_2(7)='TFIELDS =                       3 / number of fields in each row'
PDR_2(8)='TTYPE1  = ''CHANNEL ''            / label for field'
PDR_2(9)='TFORM1  = ''1I      ''            / format of field'
PDR_2(10)='TTYPE2  = ''E_MIN  ''            / label for field'
PDR_2(11)='TFORM2  = ''1E     ''            / format of field'
PDR_2(12)='TTYPE3  = ''E_MAX  ''            / label for field'
PDR_2(13)='TFORM3  = ''1E     ''            / format of field'
PDR_2(14)='EXTNAME = ''EBOUNDS''            / Extension name'
PDR_2(15)='TELESCOP= ''CHAND-1''            / Telescope or mission name'
PDR_2(16)='ORIGIN  = ''XSM-team''           / Origin of FITS file'
PDR_2(17)='INSTRUME= ''XSM    ''            / Instrument name'
PDR_2(18)='HDUCLASS= ''OGIP   ''            / Format conforms mostly to OGIP standards'
PDR_2(19)='HDUVERS = ''1.2.0  ''            / Version of format'
PDR_2(20)='HDUCLAS1= ''RESPONSE''           / Dataset contains response information'
PDR_2(21)='HDUCLAS2= ''EBOUNDS''            / Extension contains energy'
PDR_2(22)='CHANTYPE= ''PHA    ''            / Type of detector channels'
PDR_2(23)='DETCHANS=                    512 / Total number of PI channels in the full matrix'
PDR_2(24)='TUNIT2  = ''keV    ''            / Unit of this field'
PDR_2(25)='TUNIT3  = ''keV    ''            / Unit of this field'
PDR_2(26)='FILTER  = ''none   ''            / filter not specified'

OUTFILE=RN

FXWRITE, OUTFILE, PDR_0
FXBCREATE, UNIT_1, OUTFILE, PDR_1, errmsg=errmsg
FXBCREATE, UNIT_2, OUTFILE, PDR_2, errmsg=errmsg

FOR I3=1, 512 DO BEGIN
FXBWRITE, UNIT_1, FLOAT(E_LOW(I3-1)), 1, I3
FXBWRITE, UNIT_1, FLOAT(E_HIGH(I3-1)), 2, I3
FXBWRITE, UNIT_1, N_GRP(I3-1), 3, I3
FXBWRITE, UNIT_1, F_CHAN(I3-1), 4,I3
FXBWRITE, UNIT_1, N_CHAN(I3-1), 5,I3
FXBWRITE, UNIT_1, FLOAT(HYPERMET(*,I3-1)), 6, I3
ENDFOR

CHA=INDGEN(512)

FOR J3=1, 512 DO BEGIN
FXBWRITE, UNIT_2, CHA(J3-1), 1, J3
FXBWRITE, UNIT_2, FLOAT(E_MIN(J3-1)), 2, J3
FXBWRITE, UNIT_2, FLOAT(E_MAX(J3-1)), 3, J3
ENDFOR

FXBFINISH, UNIT_1
FXBFINISH, UNIT_2

XSM_SPEC_TABLE=MRDFITS(INFILE, 1)
A_EFF=DATA.A_EFF
N1=N_ELEMENTS(A_EFF(0,*))

PLOT, 0.5*(E_LOW+E_HIGH), A_EFF(*,I), YR=[0.,0.0015], TITLE='XSM EFFECTIVE AREAS', XTITLE='NOMINAL CHANNEL ENERGY, keV', YTITLE='A_EFF, cm^2', THICK=2, CHARSIZE=1.5, CHARTHICK=2

FOR I= 0, N1-1 DO BEGIN
WAIT, 0.01
ENL=1.85 ;keV
A_EFF(0:ENL,I)=0.
OPLOT, 0.5*(E_LOW+E_HIGH), A_EFF(*,I), THICK=2
ENDFOR

PDA_0=STRARR(5)
PDA_0(0)='SIMPLE  =                    T / file does conform to FITS standard'
PDA_0(1)='BITPIX  =                    8 / number of bits per data pixel'
PDA_0(2)='NAXIS   =                    0 / number of data axes'
PDA_0(3)='EXTEND  =                    T / FITS dataset may contain extensions'
;PDA_0(4)='END'

OUTBEG = 'XSM_'
OUTEND = '.ARF'
RMF_BEG = 'XSM_'

FOR K=0, N1-1 DO BEGIN
OUTFILE=OUTBEG+strtrim(string(K),2)+OUTEND
FXWRITE, OUTFILE, PDA_0

ARFFILE=RMF_BEG+strtrim(string(K),2)+OUTEND

PDA_1=STRARR(33)
PDA_1(0)='XTENSION= ''BINTABLE''            / binary table extension'
PDA_1(1)='BITPIX  =                       8 / 8-bit bytes'
PDA_1(2)='NAXIS   =                       2 / 2-dimensional binary table'
PDA_1(3)='NAXIS1  =                      12 / width of table in bytes'
PDA_1(4)='NAXIS2  =                     512 / number of rows in table'
PDA_1(5)='PCOUNT  =                       0 / size of special data area'
PDA_1(6)='GCOUNT  =                       1 / one data group (required keyword)'
PDA_1(7)='TFIELDS =                       3 / number of fields in each row'
PDA_1(8)='TTYPE1  = ''E_LOW   ''            / label for field'
PDA_1(9)='TFORM1  = ''E       ''            / format of field: 4 b'
PDA_1(10)='TUNIT1  = ''ENERGY ''            / unit of field'
PDA_1(11)='TTYPE2  = ''E_HIGH ''            / label for field'
PDA_1(12)='TFORM2  = ''E      ''            / format of field: 4 b'
PDA_1(13)='TUNIT2  = ''ENERGY ''            / unit of field'
PDA_1(14)='TTYPE3  = ''SPECRESP''           / label for field'
PDA_1(15)='TFORM3  = ''E      ''            / format of field: 4 b'
PDA_1(16)='TUNIT3  = ''cm^2   ''            / unit of field'
PDA_1(17)='TELESCOP= ''CHAND-1''            / telescope (mission) name'
PDA_1(18)='INSTRUME= ''XSM    ''            / instrument name'
PDA_1(19)='FILTER =  ''NONE   ''            / filter information'
PDA_1(20)='CCLS0001= ''CPF    ''            / OGIP class of calibration file '
PDA_1(21)='CDTP0001= ''DATA   ''            / OGIP code for contents'
PDA_1(22)='HDUCLASS= ''OGIP   ''            / format conforms to OGIP/GSFC conventions'
PDA_1(23)='HDUCOC  = ''CAL/GEN/92-019''     / document describing the format'
PDA_1(24)='HDUCLAS1= ''RESPONSE''           / response of instrument'
PDA_1(25)='HDUCLAS2= ''SPECRESP''           / dataset contains spectral response'
PDA_1(26)='HDUVERS1= ''1.0.0  ''            / version of famoly format'
PDA_1(27)='HDUVERS2= ''1.1.0  ''            / version number of the format'
PDA_1(28)='RESPFILE= ''' +RN+ ''' / Redistribution matrix file (RMF)'
;PDA_1(28)='RESPFILE= ''FILE_NAME.RMF''      / Redistribution matrix file (RMF)'
PDA_1(29)='ANCRFILE= ''' + ARFFILE + '''          / Anc. Resp. file (ARF)'
;PDA_1(29)='ANCRFILE= ''FILE_NAME.ARF''      / Anc. Resp. file (ARF)'
PDA_1(30)='EXTNAME= ''SPECRESP''            / extension name'
PDA_1(31)='CREATOR = ''L. Alha''            / person that created this file'

FXBCREATE, UNIT_3, OUTFILE, PDA_1, errmsg=errmsg

FOR I=1, 512 DO BEGIN
FXBWRITE, UNIT_3, FLOAT(E_LOW(I-1)), 1, I
FXBWRITE, UNIT_3, FLOAT(E_HIGH(I-1)), 2, I
FXBWRITE, UNIT_3, FLOAT(A_EFF(I-1,K)), 3, I
ENDFOR
PRINT, K
FXBFINISH, UNIT_3
ENDFOR

END
